//*****************************************
// IV-21 VFD Clock Program Mega328
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
// File Name:Ad_conv.c
//
//  PC1(ADC1): CdS
//
// 2016/07/05
//  huPWQbknbj̃\[XύXAtBg쓮ǉĂhu|QPpƂ
//
//  2015/12/29 New
//  2016/07/05 modify     Taishi  IV-21pɕύX{tBg쓮ǉ
//  2018/10/17 modify     Taishi  IV-21 PipepɕύX
//*****************************************
#include				<avr/io.h>

#include				"pr_iv21_pipe.h"
#include				"Ad_conv.h"

#define					N_of_AD_data		16						// Q̊K̒lɌ

static	unsigned short	ad7_data[N_of_AD_data];
static	unsigned short	ad6_data[N_of_AD_data];
static	unsigned char	ad67_count;
static	unsigned char	ad67_conv_1;								// 1:ADC6&7 Convert running
// **********************************************************
// ************************** A/D 1 *************************
// **********************************************************

//*****************************************
// A/D 6&7 Initial
// @荞ݕs̏ԂŌĂ΂Ƃ
//  ADC6: Switch1
//  ADC7: +24V (24 / 10)
//*****************************************
void	ad67_init(void)
{
	unsigned char	i;

	ad67_count = 0;
	for(i = 0; i < N_of_AD_data; i++){
		ad6_data[i] = 0;
		ad7_data[i] = 0;
	}


	PRR &= ~(1 << PRADC);																	// ADCғ
//	DIDR0 |= (1 << ADC7D);																	// AiO͐ݒ AD7 ͖

#if	FULL_VOLT100 ==	110																		// `^cdPDPu̎
	ADMUX = ( (1 << REFS1) | (1 << REFS0) | (0 << MUX3) | (1 << MUX2) | (1 << MUX1) | (1 << MUX0) );		// PDPudgp, Select ADC7
#else
	ADMUX = ( (0 << REFS1) | (1 << REFS0) | (0 << MUX3) | (1 << MUX2) | (1 << MUX1) | (1 << MUX0) );		// ubbdgp, Select ADC7
#endif
	ADCSRA = ( (1 << ADEN) | (1 << ADSC) | (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0) );	// A/D, A/DϊJn, CK/128=8MHz/128=62.5kHz(16uS) --> 208uS
	ad67_conv_1 = 1;																		// 1:ADC6&7 Convert running

}
//*****************************************
// A/D 6&7 close
//*****************************************
void	ad7_close(void)
{
	ADCSRA = 0;																				// A/Ds
	ad67_conv_1 = 0;																		// 0:ADC6&7 Convert Not running
}
//*****************************************
// A/D 7 Set A/D data to Data Buffer
//  ϊIĂȂ́@Ȃ
//*****************************************
void	ad67_set_data(void)
{
	if( (ADCSRA & (1 << ADIF)) != 0){								// `^cϊ
		ADCSRA |= (1 << ADIF);										// `^cϊtO폜
		if( ad67_conv_1 == 0){										// ADC6&7 
			;														// Ȃ
		}else{
			if( ad67_conv_1 == 1){										// ADC6 ϊ
				ad6_data[ad67_count] = ADCW;
				ADMUX &= ( (1 << REFS1) | (1 << REFS0) );				// dwrbg͎c
				ADMUX |= ( (1 << MUX2) | (1 << MUX1) | (1 << MUX0) );	// Select ADC7
				ad67_conv_1 = 2;										// ADC7 ϊ
			}else{														// ADC7 ϊ
				ad7_data[ad67_count] = ADCW;
				ad67_count++;
				ad67_count &= (N_of_AD_data - 1);
				ADMUX &= ( (1 << REFS1) | (1 << REFS0) );				// dwrbg͎c
				ADMUX |= ( (1 << MUX2) | (1 << MUX1) | (0 << MUX0) );	// Select ADC6
				ad67_conv_1 = 1;										// ADC6 ϊ
			}
			ADCSRA |= (1 << ADSC);										// A/DϊJn
		}
	}
}
//*****************************************
// A/D 6 Get A/D data
//  obt@ɓĂf[^𕽋ςĎ擾
//*****************************************
unsigned short	ad6_get_data(void)
{
	unsigned char	i;
	unsigned short	sum;

	sum = 0;
	for(i = 0; i < N_of_AD_data; i++){						// obt@Sđ
		sum += ad6_data[i];
	}

	sum /= N_of_AD_data;									// f[^Ŋĕϒlɂ

	return(sum);
}
//*****************************************
// A/D 7 Get A/D data
//  obt@ɓĂf[^𕽋ςĎ擾
//*****************************************
unsigned short	ad7_get_data(void)
{
	unsigned char	i;
	unsigned short	sum;

	sum = 0;
	for(i = 0; i < N_of_AD_data; i++){						// obt@Sđ
		sum += ad7_data[i];
	}

	sum /= N_of_AD_data;									// f[^Ŋĕϒlɂ

	return(sum);
}
